SystemOrganization addCategory: #'Magritte-Tests-XMLBinding'!

GRObject subclass: #MXTestPerson
	instanceVariableNames: 'name address favouriteHobby otherHobbies otherAddresses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXTestPerson class methodsFor: 'defaults' stamp: 'jvds 10/7/2010 18:43'!
allHobbies

	^#( 'Tennis' 'Golf' 'Football' 'Chess' 'Smalltalk programming' )! !

!MXTestPerson methodsFor: 'accessing' stamp: 'jvds 10/5/2010 21:21'!
address
	^ address! !

!MXTestPerson methodsFor: 'accessing' stamp: 'jvds 10/5/2010 21:21'!
address: anObject
	address := anObject! !

!MXTestPerson methodsFor: 'accessing-description' stamp: 'NickAger 1/31/2012 13:23'!
descriptionAddress
	<magritteDescription>
	^ MAToOneRelationDescription new
		accessor: #address;
		label: 'Address';
		classes: (Array with: MXTestAddress);
		beXmlElement;
		priority: 20;
		yourself! !

!MXTestPerson methodsFor: 'accessing-description' stamp: 'NickAger 2/3/2012 13:53'!
descriptionContainer: aDescription
	<magritteContainer>
	"Note: rather than overridding <magritteContainer> to define #xmlElementName: an alternative is to derive
	your object from MXObject and override MXSimpleObject class>>xmlElementName
	see: MXXmlElementTarget>>#getInstanceFrom:description: and MXXmlClassNameAttributeTarget>>#getInstanceFrom:description"
	^ aDescription
		xmlElementName: 'person';
		yourself! !

!MXTestPerson methodsFor: 'accessing-description' stamp: 'NickAger 1/31/2012 13:24'!
descriptionFavouriteHobby
	<magritteDescription>
	^ MASingleOptionDescription new
		accessor: #favouriteHobby;
		label: 'Favourite hobby';
		options: self class allHobbies;
		beXmlElement;
		priority: 30;
		yourself! !

!MXTestPerson methodsFor: 'accessing-description' stamp: 'NickAger 2/1/2012 14:28'!
descriptionName
	<magritteDescription>
	^ MAStringDescription new
		accessor: #name;
		label: 'Name';
		beXmlAttribute;
		priority: 10;
		yourself! !

!MXTestPerson methodsFor: 'accessing-description' stamp: 'NickAger 1/31/2012 13:23'!
descriptionOtherAddresses
	<magritteDescription>
	^ MAToManyRelationDescription new
		accessor: #otherAddresses;
		label: 'Other addresses';
		classes: (Array with: MXTestAddress);
		beXmlElement;
		priority: 40;
		yourself! !

!MXTestPerson methodsFor: 'accessing-description' stamp: 'NickAger 3/29/2012 17:42'!
descriptionOtherHobbies
	<magritteDescription>
	^ MAMultipleOptionDescription new
		accessor: #otherHobbies;
		label: 'Other hobbies';
		options: self class allHobbies;
		beXmlElement;
		priority: 50;
		yourself! !

!MXTestPerson methodsFor: 'accessing' stamp: 'jvds 10/7/2010 18:32'!
favouriteHobby
	^ favouriteHobby! !

!MXTestPerson methodsFor: 'accessing' stamp: 'jvds 10/7/2010 18:32'!
favouriteHobby: anObject
	favouriteHobby := anObject! !

!MXTestPerson methodsFor: 'accessing' stamp: 'jvds 10/5/2010 21:21'!
name
	^ name! !

!MXTestPerson methodsFor: 'accessing' stamp: 'jvds 10/5/2010 21:21'!
name: anObject
	name := anObject! !

!MXTestPerson methodsFor: 'accessing' stamp: 'jvds 10/7/2010 18:32'!
otherAddresses
	^ otherAddresses! !

!MXTestPerson methodsFor: 'accessing' stamp: 'jvds 10/7/2010 18:32'!
otherAddresses: anObject
	otherAddresses := anObject! !

!MXTestPerson methodsFor: 'accessing' stamp: 'jvds 10/7/2010 18:32'!
otherHobbies
	^ otherHobbies! !

!MXTestPerson methodsFor: 'accessing' stamp: 'jvds 10/7/2010 18:32'!
otherHobbies: anObject
	otherHobbies := anObject! !

MXTestPerson subclass: #MXTestPersonAttributeCustom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXTestPersonAttributeCustom methodsFor: 'accessing-description' stamp: 'NickAger 2/1/2012 14:36'!
descriptionName
	^ super descriptionName
		xmlAttributeName: 'p-name';
		yourself! !

MXTestPerson subclass: #MXTestPersonAttributeNested
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXTestPersonAttributeNested methodsFor: 'accessing-description' stamp: 'NickAger 2/1/2012 14:42'!
descriptionName
	^ super descriptionName
		beXmlChildAttribute;
		yourself! !

MXTestPerson subclass: #MXTestPersonAttributeNestedCustom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXTestPersonAttributeNestedCustom methodsFor: 'accessing-description' stamp: 'NickAger 2/1/2012 14:47'!
descriptionName
	^ super descriptionName
		beXmlChildAttribute;
		xmlElementName: 'a';
		xmlAttributeName: 'b'; 
		yourself! !

MXTestPerson subclass: #MXTestPersonBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXTestPersonBlock methodsFor: 'accessing-description' stamp: 'NickAger 2/1/2012 14:50'!
descriptionName
	^ super descriptionName
		xmlReadBlock: [ :elem | elem attributeAt: 'blck' ]
			writeBlock: [ :elem :object | elem attributeAt: 'blck' put: object ]
		yourself! !

MXTestPerson subclass: #MXTestPersonBlockWithNil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXTestPersonBlockWithNil methodsFor: 'accessing-description' stamp: 'NickAger 2/1/2012 14:54'!
descriptionName
	^ super descriptionName
		xmlReadBlock: [ :elem | elem attributeAt: 'blck' ifAbsent: [ nil ] ]
			writeBlock: [ :elem :object | object notNil ifTrue: [ elem attributeAt: 'blck' put: object ] ]
		yourself! !

MXTestPerson subclass: #MXTestPersonContainerElementWithTypeAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXTestPersonContainerElementWithTypeAttribute methodsFor: 'accessing-description' stamp: 'NickAger 2/3/2012 13:56'!
descriptionContainer: aDescription
	<magritteContainer>
	^ aDescription
		xmlElementName: 'person' classAttribute: 'stclass';
		yourself! !

MXTestPerson subclass: #MXTestPersonElementCustom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXTestPersonElementCustom methodsFor: 'accessing-description' stamp: 'NickAger 2/1/2012 15:09'!
descriptionName
	^ MAStringDescription new
		accessor: #name;
		label: 'Name';
		xmlElementName: 'p-name';
		yourself! !

MXTestPerson subclass: #MXTestPersonElementDefault
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXTestPersonElementDefault methodsFor: 'accessing-description' stamp: 'NickAger 2/1/2012 15:09'!
descriptionName
	^ MAStringDescription new
		accessor: #name;
		label: 'Name';
		beXmlElement;
		yourself! !

MXTestPerson subclass: #MXTestPersonWithEmail
	instanceVariableNames: 'email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXTestPersonWithEmail methodsFor: 'descriptions' stamp: 'NickAger 2/16/2012 18:21'!
descriptionEmail
	<magritteDescription>
	^ MAStringDescription new
		accessor: #email;
		label: 'Email';
		priority: 30;
		yourself! !

!MXTestPersonWithEmail methodsFor: 'accessing' stamp: 'NickAger 2/16/2012 18:15'!
email
	^ email! !

!MXTestPersonWithEmail methodsFor: 'accessing' stamp: 'NickAger 2/16/2012 18:15'!
email: anObject
	email := anObject! !

GRObject subclass: #MXTestSimpleRss
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXTestSimpleRss methodsFor: 'magritte description' stamp: 'NickAger 3/27/2012 13:39'!
descriptionContainer: aDescription
	<magritteContainer>
	^ aDescription
		xmlElementName: 'rss';
		yourself! !

!MXTestSimpleRss methodsFor: 'accessing' stamp: 'NickAger 3/27/2012 13:40'!
link
	^ link! !

!MXTestSimpleRss methodsFor: 'accessing' stamp: 'NickAger 3/27/2012 13:40'!
link: anObject
	link := anObject! !

!MXTestSimpleRss methodsFor: 'magritte description' stamp: 'NickAger 3/27/2012 13:39'!
linkDescription
	<magritteDescription>
	^ MAStringDescription new
		accessor: #link;
		label: 'Link';
		priority: 200;
		beXmlElement;
		yourself! !

TestCase subclass: #MXDescriptionPropagationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXDescriptionPropagationTest methodsFor: 'helpers' stamp: 'NickAger 1/31/2012 12:49'!
reducedSimpleDescription
	| simpleObject |
	simpleObject := MXSimpleObject new.
	^ (simpleObject descriptionTitle, 
		simpleObject descriptionDate)
			xmlElementName: MXSimpleObject xmlElementName;
			kind: MXSimpleObject ! !

!MXDescriptionPropagationTest methodsFor: 'fixtures' stamp: 'NorbertHartl 10/12/2011 15:23'!
simpleObject
	^ MXSimpleObject new
		title: 'A title';
		abstract: 'A longer text as abstract';
		token: 'article';
		index: 100000 atRandom;
		date: Date today! !

!MXDescriptionPropagationTest methodsFor: 'helpers' stamp: 'NorbertHartl 10/12/2011 15:34'!
simpleObjectXml
	^ '<simpleobject title="A title" index="15708"><abstract>A longer text as abstract</abstract><token type="article" /><date>12 October 2011</date></simpleobject>'! !

!MXDescriptionPropagationTest methodsFor: 'tests' stamp: 'NickAger 1/31/2012 12:49'!
testReadDefaultDescription
	| obj |
	obj := self simpleObject magritteDescription fromXml: self simpleObjectXml.
	self assert: obj title notNil.
	self assert: obj date notNil.
	self assert: obj abstract notNil! !

!MXDescriptionPropagationTest methodsFor: 'tests' stamp: 'NorbertHartl 10/12/2011 15:41'!
testReadReducedInherited
	| obj |
	obj := self reducedSimpleDescription fromXml: self simpleObjectXml.
	self assert: obj title notNil.
	self assert: obj date notNil.
	self assert: obj abstract notNil! !

!MXDescriptionPropagationTest methodsFor: 'tests' stamp: 'NorbertHartl 10/12/2011 15:41'!
testReadReducedInjected
	| obj |
	obj := self reducedSimpleDescription bePreserved fromXml: self simpleObjectXml.
	self assert: obj title notNil.
	self assert: obj date notNil.
	self assert: obj abstract isNil! !

!MXDescriptionPropagationTest methodsFor: 'tests' stamp: 'NorbertHartl 10/12/2011 15:33'!
testWriteReducedDescription
	| doc |
	doc := self reducedSimpleDescription toXmlDocument: self simpleObject.
	self assert: doc firstElement elements size = 1.
	self assert: doc firstElement attributes size = 1.! !

TestCase subclass: #MXXmlGRObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXXmlGRObjectTest methodsFor: 'tests' stamp: 'NickAger 3/29/2012 17:27'!
testAsXmlExportableDefaultFalse

	| person xml created |
	
	person := MXTestPersonWithEmail new
		name: 'Pete';
		otherHobbies: #( 'Tennis' 'Golf' );
		email: 'pete@tennisgolf.com'
		yourself.
		
	xml := (person asXmlExportableDefault: false) greaseString.
	
	self assert: xml = '<person name="Pete"><otherHobbies>Tennis</otherHobbies><otherHobbies>Golf</otherHobbies></person>'.! !

!MXXmlGRObjectTest methodsFor: 'tests' stamp: 'NickAger 3/29/2012 17:28'!
testAsXmlExportableDefaultTrue
	| person xml |
	
	person := MXTestPersonWithEmail new
		name: 'Pete';
		otherHobbies: #( 'Tennis' 'Golf' );
		email: 'pete@tennisgolf.com'
		yourself.
		
	"note the xml below includes an email xml element even though the email description doesn't have any specific XML attributes defined
	the:
	   person asXmlExportableDefault: true
	the 'true' exports using default attributes.'"	
	xml := (person asXmlExportableDefault: true) greaseString.
	self assert: xml = '<person name="Pete"><email>pete@tennisgolf.com</email><otherHobbies>Tennis</otherHobbies><otherHobbies>Golf</otherHobbies></person>'.! !

TestCase subclass: #MXXmlMultipleElementsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXXmlMultipleElementsTest methodsFor: 'private' stamp: 'NickAger 3/27/2012 13:44'!
rssXML
	"Note this is modifed for the purpose of the test. normally there would be a <channel> wrapper around the feed.
	for Rss parsing see:
		 http://ss3.gemstone.com/ss/TopFeeder"
	
	^ '<?xml version="1.0" encoding="UTF-8"?>
<!!-- generator="wordpress/2.0.2" -->
<rss version="2.0" 
	xmlns:content="http://purl.org/rss/1.0/modules/content/"
	xmlns:wfw="http://wellformedweb.org/CommentAPI/"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:atom="http://www.w3.org/2005/Atom"
	>

	<title>Black Bag Operations Network</title>
	<atom:link href="http://www.blackbagops.net/feed/" rel="self" type="application/rss+xml" />
	<link>http://www.blackbagops.net</link>
	<description>Weapons and Intelligence in the War Against "Them"</description>
	<pubDate>Tue, 27 Feb 2007 03:44:13 +0000</pubDate>
	<generator>http://wordpress.org/?v=2.0.2</generator>
	<language>en</language>
</rss>'! !

!MXXmlMultipleElementsTest methodsFor: 'tests' stamp: 'NickAger 3/27/2012 13:45'!
testMultipleElements
	| rssFeed |
	rssFeed := MXTestSimpleRss fromXml: self rssXML.
	
	self assert: rssFeed link equals: 'http://www.blackbagops.net'.! !

TestCase subclass: #MXXmlObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXXmlObjectTest methodsFor: 'fixtures' stamp: 'NorbertHartl 2/21/2010 08:04'!
simpleObject
	^ MXSimpleObject new
		title: 'A title';
		abstract: 'A longer text as abstract';
		token: 'article';
		index: 100000 atRandom;
		date: Date today! !

!MXXmlObjectTest methodsFor: 'testing' stamp: 'jvds 11/6/2010 13:14'!
testAttributeWrite
	| object xml |
	object := MXSimpleObject new
		title: 'A title'.
	xml := object toXml.
	self assert: (xml attributeAt: 'title') = 'A title'! !

!MXXmlObjectTest methodsFor: 'testing' stamp: 'jvds 11/6/2010 13:16'!
testChildNodeAttributeWrite
	| object xml |
	object := MXSimpleObject new
		token: 'a subelement attribute'.
	xml := object toXml.
	"<simpleobject><token type='a subelement attribute'/> </simpleobject>"
	self assert: (xml elementAt: 'token') notNil.
	self assert: ((xml elementAt: 'token') attributeAt: 'type') = 'a subelement attribute'! !

!MXXmlObjectTest methodsFor: 'testing' stamp: 'NickAger 2/1/2012 16:52'!
testChildNodeContentWrite
	| object xmlString |
	object := MXSimpleObject new
		abstract: 'Some words as abstract'.
	xmlString := String streamContents: [:stream|
		object writeXMLOn: stream].
	self assert: xmlString = '<simpleobject><abstract>Some words as abstract</abstract></simpleobject>'! !

!MXXmlObjectTest methodsFor: 'testing' stamp: 'NickAger 1/31/2012 13:28'!
testDescriptionConfigurationPropagation
	| object desc xml result |
	object := self simpleObject.
	desc := object magritteDescription collect: [:each| 
		(each label = 'Abstract') 
			ifTrue: [
				each copy
					xmlReadBlock: [:elem| elem attributeAt: 'customAbstract'] 
					writeBlock: [:elem :obj| elem attributeAt: 'customAbstract' put: obj ]]
			ifFalse: [ each ]].
	
	xml := desc toXml: object.
	result := desc fromXml: xml.
	self assert: result abstract = object abstract
	! !

!MXXmlObjectTest methodsFor: 'testing' stamp: 'NickAger 2/1/2012 16:53'!
testNodeContentWrite
	| object xmlString |
	object := MXSimpleObject new
		abstract: 'Some words as abstract'.
	xmlString := String streamContents: [:stream|
		object writeXMLOn: stream].
	self assert: xmlString = '<simpleobject><abstract>Some words as abstract</abstract></simpleobject>'! !

!MXXmlObjectTest methodsFor: 'testing' stamp: 'NickAger 2/1/2012 16:53'!
testObjectRoundtrip
	| object xmlString created |
	object := self simpleObject.
	xmlString := String streamContents: [:stream|
		object writeXMLOn: stream].
	created := MXSimpleObject fromXml: xmlString.

	self assert: (object title = created title).
	self assert: (object index = created index).
	self assert: (object date = created date).
	self assert: (object abstract = created abstract).
	self assert: (object token = created token)! !

!MXXmlObjectTest methodsFor: 'testing' stamp: 'NickAger 2/3/2012 13:21'!
testXmlDocumentCreationFromDescription
	| object |
	object := self simpleObject.
	
	self assert: ((object magritteDescription toXmlNode: object) class = XMLElement).
	self assert: ((object magritteDescription toXmlDocument: object) class = XMLDocument )
! !

!MXXmlObjectTest methodsFor: 'testing' stamp: 'NorbertHartl 12/21/2010 15:17'!
testXmlDocumentCreationFromObject
	| object |
	object := self simpleObject.
	
	self assert: (object toXml class = XMLElement).
	self assert: ((object toXmlDocument) class = XMLDocument ).
! !

TestCase subclass: #MXXmlPersonReferenceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXXmlPersonReferenceTest methodsFor: 'tests' stamp: 'NickAger 3/29/2012 17:47'!
testMultipleOption

	| person xml created |
	
	person := MXTestPerson new
		name: 'Pete';
		otherHobbies: #( 'Tennis' 'Golf' );
		yourself.
		
	xml := person magritteDescription toXmlNode: person.
	self assert: ((String streamContents: [:s|
		xml writeXMLOn: (XMLWriter on: s)])  includesSubString: '<otherHobbies>Tennis</otherHobbies><otherHobbies>Golf</otherHobbies>').
	
	created := MXTestPerson new magritteDescription fromXmlNode: xml.
	self assert: (person otherHobbies hasEqualElements: created otherHobbies).! !

!MXXmlPersonReferenceTest methodsFor: 'tests' stamp: 'NickAger 1/31/2012 13:29'!
testSingleOption

	| person xml created |
	
	person := MXTestPerson new
		name: 'Pete';
		favouriteHobby: 'Tennis';
		yourself.
		
	xml := person magritteDescription toXmlNode: person.
	
	created := MXTestPerson new magritteDescription fromXmlNode: xml.
	
	self assert: (person favouriteHobby = created favouriteHobby).! !

!MXXmlPersonReferenceTest methodsFor: 'tests' stamp: 'NickAger 1/31/2012 13:29'!
testToManyRelation

	| person xml created |
	
	person := MXTestPerson new
		name: 'Pete';
		otherAddresses: (OrderedCollection new
			add: (MXTestStreetAddress new
				street: 'Noordeinde';
				city: 'Delft';
				postalCode: '2611KH');
			add: (MXTestStreetAddress new
				street: 'Rubenslaan';
				city: 'Utrecht';
				postalCode: '3582JD');
			yourself).
		
	xml := person magritteDescription toXmlNode: person.
	
	created := MXTestPerson new magritteDescription fromXmlNode: xml.
	
	self assert: (person otherAddresses size = created otherAddresses size).
	self assert: (person otherAddresses last street = created otherAddresses last street).! !

!MXXmlPersonReferenceTest methodsFor: 'tests' stamp: 'NickAger 1/31/2012 13:31'!
testToOneRelation

	| person xml created |
	
	person := MXTestPerson new
		name: 'Pete';
		address: (MXTestStreetAddress new
			street: 'Noordeinde';
			city: 'Delft';
			postalCode: '2611KH';
			yourself);
		yourself.
		
	xml := person magritteDescription toXmlNode: person.
	
	created := MXTestPerson new magritteDescription fromXmlNode: xml.
	
	self assert: (person name = created name).
	self assert: (person address class = created address class).
	self assert: (person address postalCode = created address postalCode)! !

TestCase subclass: #MXXmlPersonTargetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXXmlPersonTargetTest methodsFor: 'testing' stamp: 'NickAger 2/1/2012 14:39'!
testAttributeCustom
	| description person node created |

	person := MXTestPersonAttributeCustom new
		name: 'Pepe';
		yourself.
	
	description := person magritteDescription.
	node := description toXmlNode: person.
	
	"<person p-name='Pepe'></person>"
	self assert: (node attributeAt: 'p-name') = person name.
	
	created := description fromXmlNode: node.
	self assert: created name = person name.! !

!MXXmlPersonTargetTest methodsFor: 'testing' stamp: 'NickAger 2/1/2012 14:41'!
testAttributeDefault
	| description person node created |
	
	person := MXTestPerson new
		name: 'Pepe';
		yourself.
		
	description := person magritteDescription.
	node := description toXmlNode: person.
	
	"<person name='Pepe'></person>"
	self assert: (node attributeAt: 'name')= person name.
	
	created := description fromXmlNode: node.
	self assert: created name = person name! !

!MXXmlPersonTargetTest methodsFor: 'testing' stamp: 'NickAger 2/1/2012 14:44'!
testAttributeNested
	| description person node created |

	person := MXTestPersonAttributeNested new
		name: 'Pepe';
		yourself.
	
	description := person magritteDescription.
	node := description toXmlNode: person.
	
	"<name><name name='Pepe'/></name>"
	self assert: ((node elementAt: 'name') attributeAt: 'name') = person name.
	
	created := description fromXmlNode: node.
	self assert: created name = person name.! !

!MXXmlPersonTargetTest methodsFor: 'testing' stamp: 'NickAger 2/1/2012 14:49'!
testAttributeNestedCustom
	| description person node created |
	
	person := MXTestPersonAttributeNestedCustom new
		name: 'Pepe';
		yourself.

	description := person magritteDescription.
	node := description toXmlNode: person.
	
	"<person><a b='Pepe'/></person>"
	self assert: ((node elementAt: 'a') attributeAt: 'b') = person name.
	
	created := description fromXmlNode: node.
	self assert: created name = person name.! !

!MXXmlPersonTargetTest methodsFor: 'testing' stamp: 'NickAger 2/1/2012 14:52'!
testBlock
	| description person node created |
	
	person := MXTestPersonBlock new 
		name: 'Pepe'; 
		yourself.
		
	description := person magritteDescription.
	node := description toXmlNode: person.
	
	"<person blck='Pepe'></person>"
	self assert: (node attributeAt: 'blck') = person name.
	
	created := description fromXmlNode: node.
	self assert: created name = person name! !

!MXXmlPersonTargetTest methodsFor: 'testing' stamp: 'NickAger 2/1/2012 14:55'!
testBlockWithNil
	| description person node created |
	
	person := MXTestPersonBlockWithNil new
		name: nil; 
		yourself.
		
	description := person magritteDescription.
	node := description toXmlNode: person.
	
	"<person></person>"
	self assert: (node attributeAt: 'blck2' ifAbsent: [ nil] ) isNil.
	
	created := description fromXmlNode: node.
	self assert: created name isNil! !

!MXXmlPersonTargetTest methodsFor: 'testing' stamp: 'NickAger 2/1/2012 12:19'!
testContainerElementCustom
	| description person node created |

	person := MXTestPerson new.
	description := person magritteDescription.
	node := description toXmlNode: person.
	
	"<person></person>"
	self assert: node name = 'person'.
	
	created := description fromXmlNode: node.
	self assert: created class = person class! !

!MXXmlPersonTargetTest methodsFor: 'testing' stamp: 'NickAger 2/1/2012 14:57'!
testContainerElementWithTypeAttribute
	| description person node created |
	
	person := MXTestPersonContainerElementWithTypeAttribute new.
	
	description := person magritteDescription.
	node := description toXmlNode: person.
	
	"<person strclass='MXTestPersonContainerElementWithTypeAttribute></person>"
	self assert: node name = 'person'.
	self assert: (node attributeAt: 'stclass') = #MXTestPersonContainerElementWithTypeAttribute.
	
	created := description fromXmlNode: node.
	self assert: created class = person class! !

!MXXmlPersonTargetTest methodsFor: 'testing' stamp: 'NickAger 2/1/2012 15:04'!
testElementCustom
	| description person node created |

	person := MXTestPersonElementCustom new
		name: 'Pepe';
		yourself.
	
	description := person magritteDescription.
	node := description toXmlNode: person.
	
	"<person><p-name>Pepe</p-name></person>"
	self assert: (node elementAt: 'p-name') contentString = person name.
	
	created := description fromXmlNode: node.
	self assert: created name = person name.! !

!MXXmlPersonTargetTest methodsFor: 'testing' stamp: 'NickAger 2/1/2012 15:15'!
testElementDefault
	| description person node created |

	person := MXTestPersonElementDefault new
		name: 'Pepe';
		yourself.
	
	description := person magritteDescription.
	node := description toXmlNode: person.
	
	"<person><name>Pepe</name></person>"
	self assert: (node elementAt: 'name') contentString = person name.
	
	created := description fromXmlNode: node.
	self assert: created name = person name.! !

TestCase subclass: #MXXmlRelationEmbedTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXXmlRelationEmbedTest methodsFor: 'fixtures' stamp: 'NorbertHartl 3/15/2010 18:59'!
embedObject
	^ MXRelationEmbedSource new
		title: 'A title';
		target: (
			MXRelationEmbedTarget new
				name: 'A name')! !

!MXXmlRelationEmbedTest methodsFor: 'testing' stamp: 'NickAger 2/1/2012 16:53'!
testEmbedWrite
	| object xmlString |
	object := self embedObject.
	xmlString := String streamContents: [:stream|
		object writeXMLOn: stream].
	self assert: (xmlString indexOfSubCollection: 'embedTargetName="A name"') > 0.
	self assert: (xmlString indexOfSubCollection: 'title="A title"') > 0! !

TestCase subclass: #MXXmlRelationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXXmlRelationTest methodsFor: 'helpers' stamp: 'NorbertHartl 2/17/2010 09:04'!
findTitle: aString in: aCollection
	^ (aCollection 
		detect: [:each| each title = aString]
		ifNone: [ nil ]) notNil! !

!MXXmlRelationTest methodsFor: 'fixtures' stamp: 'NorbertHartl 2/17/2010 13:37'!
onoToMany
	^ MXOneToManySource new
		label: 'A label';
		targets: (
			OrderedCollection new
				add:(MXRelationTarget new
					title: 'title1');
				add:(MXRelationTarget new
					title: 'title2');
				add:(MXRelationTarget new
					title: 'title3');
				yourself
			);
		inlineTargets: (
			OrderedCollection new
				add:(MXRelationInlineTarget new
					title: 'inline title1');
				add:(MXRelationInlineTarget new
					title: 'inline title2');
				add:(MXRelationInlineTarget new
					title: 'inline title3');
				yourself
			)! !

!MXXmlRelationTest methodsFor: 'fixtures' stamp: 'NorbertHartl 2/17/2010 13:37'!
onoToOne
	^ MXOneToOneSource new
		label: 'A label';
		target: (
			MXRelationTarget new
				title: 'A title');
		inlineTarget: (
			MXRelationInlineTarget new
				title: 'An inline title')! !

!MXXmlRelationTest methodsFor: 'testing' stamp: 'jvds 11/6/2010 13:08'!
testOneToManyElementWrite
	| object xml |
	object := MXOneToManySource new
		label: 'A label';
		targets: (
			OrderedCollection new
				add:(MXRelationTarget new
					title: 'title1');
				add:(MXRelationTarget new
					title: 'title2');
				yourself).
	xml := object toXml.
	"<toManySource label='A label'><elementTargets><elementtarget title='title1'/> <elementtarget title='title2'/></elementTargets></toManySource>"
	self assert: (xml elementAt: 'elementTargets') notNil.
	self assert: ((xml elementAt: 'elementTargets') elementsAt: 'elementtarget') size = 2! !

!MXXmlRelationTest methodsFor: 'testing' stamp: 'jvds 11/6/2010 13:06'!
testOneToManyInlineWrite
	| object xml |
	object := MXOneToManySource new
		label: 'A label';
		inlineTargets: (
			OrderedCollection new
				add:(MXRelationInlineTarget new
					title: 'title1');
				add:(MXRelationInlineTarget new
					title: 'title2');
				yourself).
	xml := object toXml.
	"<toManySource label='A label'><inlineTarget title='title1'/> <inlineTarget title='title2'/> </toManySource>'"
	self assert: (xml elementsAt: 'inlineTarget') size = 2
! !

!MXXmlRelationTest methodsFor: 'testing' stamp: 'NickAger 2/1/2012 16:52'!
testOneToManyRoundtrip
	| object xmlString created |
	object := self onoToMany.
	xmlString := String streamContents: [:stream|
		object writeXMLOn: stream].
	created := MXOneToManySource fromXml: xmlString.
	self assert: object label = created label.
	self assert: created targets notNil.
	self assert: created targets notEmpty.
	self assert: object targets size = created targets size.
	self assert: (self findTitle: 'title1' in: created targets).
	self assert: (self findTitle: 'title2' in: created targets).
	self assert: (self findTitle: 'title3' in: created targets).
	self assert: created inlineTargets notEmpty.
	self assert: (self findTitle: 'inline title1' in: created inlineTargets).
	self assert: (self findTitle: 'inline title2' in: created inlineTargets).
	self assert: (self findTitle: 'inline title3' in: created inlineTargets).
! !

!MXXmlRelationTest methodsFor: 'testing' stamp: 'jvds 11/6/2010 13:04'!
testOneToOneElementWrite
	| object xml |
	object := MXOneToOneSource new
		label: 'A label';
		target: (
			MXRelationTarget new
				title: 'A title').
	xml := object toXml.
	"<toOneSource label='A label'><toOne><elementtarget title='A title'/> </toOne></toOneSource>"
	self assert: (xml elementAt: 'toOne') notNil.
	self assert: ((xml elementAt: 'toOne') elementAt: 'elementtarget') notNil! !

!MXXmlRelationTest methodsFor: 'testing' stamp: 'jvds 11/6/2010 13:00'!
testOneToOneInlineWrite
	| object xml |
	object := MXOneToOneSource new
		label: 'A label';
		inlineTarget: (
			MXRelationInlineTarget new
				title: 'A title').
	xml := object toXml.
	
	"<toOneSource label='A label'><inlineTarget title='A title'/> </toOneSource>"
	self assert: (xml elementAt: 'inlineTarget') notNil.
	self assert: (xml elementAt: 'inlineTarget') hasElements not.
	self assert: ((xml elementAt: 'inlineTarget') attributeAt: 'title') = 'A title'
	! !

!MXXmlRelationTest methodsFor: 'testing' stamp: 'NickAger 2/1/2012 16:52'!
testOneToOneRoundtrip
	| object xmlString created |
	object := self onoToOne.
	xmlString := String streamContents: [:stream|
		object writeXMLOn: stream].
	created := MXOneToOneSource fromXml: xmlString.
	self assert: object label = created label.
	self assert: created target notNil.
	self assert: object target title = created target title.
	self assert: object inlineTarget title = created inlineTarget title.
! !

TestCase subclass: #MXXmlTargetTest
	instanceVariableNames: 'element person'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXXmlTargetTest methodsFor: 'testing' stamp: 'jvds 10/22/2010 09:44'!
doTestText: aXmlTarget

	| value |
	
	aXmlTarget addText: 'text' to: self element.
	value := aXmlTarget getTextFrom: self element.
	self assert: (value = 'text')
! !

!MXXmlTargetTest methodsFor: 'testing' stamp: 'jvds 10/22/2010 09:52'!
doTestTextEmpty: aXmlTarget

	| value |
	
	value := aXmlTarget getTextFrom: self element.
	self assert: value isNil
! !

!MXXmlTargetTest methodsFor: 'accessing' stamp: 'jvds 10/22/2010 09:33'!
element

	^element ifNil: [ element := XMLElement named: 'test' ]! !

!MXXmlTargetTest methodsFor: 'accessing' stamp: 'jvds 10/22/2010 10:00'!
person

	^person ifNil: [
		person := MXTestPerson new
			name: 'Pete']! !

!MXXmlTargetTest methodsFor: 'testing' stamp: 'NorbertHartl 11/13/2010 17:28'!
testNodeInlineElement

	| target node resultNode |
	
	target := MXXmlElementTarget new beInlined.
		
	node := target addNodeTo: self element.
	self assert: (node isKindOf: XMLElement).
	self assert: node = self element.
	
	resultNode := target getNodeFrom: self element.
	self assert: node = resultNode.
	! !

!MXXmlTargetTest methodsFor: 'testing' stamp: 'jvds 10/22/2010 09:50'!
testNodeNamedElement

	| target node resultNode |
	
	target := MXXmlNamedElementTarget new
		elementName: 'pipo'.
		
	node := target addNodeTo: self element.
	self assert: (node isKindOf: XMLElement).
	self assert: node name = 'pipo'.
	
	resultNode := target getNodeFrom: self element.
	self assert: node = resultNode.
	! !

!MXXmlTargetTest methodsFor: 'testing' stamp: 'jvds 10/22/2010 09:51'!
testNodeNamedElementEmpty

	| target resultNode |
	
	target := MXXmlNamedElementTarget new
		elementName: 'pipo'.
		
	resultNode := target getNodeFrom: self element.
	self assert: resultNode isNil.
	! !

!MXXmlTargetTest methodsFor: 'testing' stamp: 'jvds 10/22/2010 09:37'!
testTextAttribute

	| target |
	
	target := MXXmlAttributeTarget new
		attributeName: 'pipo'.
		
	self doTestText: target.
	self assert: (self element attributeAt: 'pipo') = 'text'.! !

!MXXmlTargetTest methodsFor: 'testing' stamp: 'jvds 10/22/2010 09:53'!
testTextAttributeEmpty

	| target |
	
	target := MXXmlAttributeTarget new
		attributeName: 'pipo'.
		
	self doTestTextEmpty: target! !

!MXXmlTargetTest methodsFor: 'testing' stamp: 'jvds 10/22/2010 09:40'!
testTextNamedElement

	| target |
	
	target := MXXmlNamedElementTarget new
		elementName: 'pipo'.
		
	self doTestText: target.
	self assert: (self element elementAt: 'pipo') notNil.
	self assert: (self element elementAt: 'pipo') contentString = 'text'.! !

!MXXmlTargetTest methodsFor: 'testing' stamp: 'jvds 10/22/2010 13:04'!
testTextNamedElementCData

	| target |
	
	target := MXXmlNamedElementTarget new
		elementName: 'pipo';
		setUseCDATASection.
		
	self doTestText: target.
	self assert: (self element elementAt: 'pipo') contentString = 'text'.
	self assert: ((self element elementAt: 'pipo') firstNode isKindOf: XMLCData)! !

!MXXmlTargetTest methodsFor: 'testing' stamp: 'jvds 10/22/2010 09:53'!
testTextNamedElementEmpty

	| target |
	
	target := MXXmlNamedElementTarget new
		elementName: 'pipo'.
		
	self doTestTextEmpty: target! !

!MXXmlTargetTest methodsFor: 'testing' stamp: 'jvds 10/22/2010 09:42'!
testTextNestedAttribute

	| target |
	
	target := MXXmlNestedAttributeTarget new
		elementName: 'e-pipo';
		attributeName: 'pipo'.
		
	self doTestText: target.
	self assert: (self element elementAt: 'e-pipo') notNil.
	self assert: ((self element elementAt: 'e-pipo') attributeAt: 'pipo') = 'text'.! !

!MXXmlTargetTest methodsFor: 'testing' stamp: 'jvds 10/22/2010 09:53'!
testTextNestedAttributeEmpty

	| target |
	
	target := MXXmlNestedAttributeTarget new
		elementName: 'e-pipo';
		attributeName: 'pipo'.
		
	self doTestTextEmpty: target! !

!MXXmlTargetTest methodsFor: 'testing' stamp: 'jvds 10/22/2010 13:00'!
testUndefined

	| target |
	
	target := MXXmlAttributeTarget new
		attributeName: 'pipo'.
		
	target addUndefinedTo: self element.
	self assert: (self element elementAt: 'pipo') isNil! !

TestCase subclass: #MXXmlTypesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 8/5/2010 00:12'!
testBooleanRead
	| created xmlString |
	xmlString := '<typesobject boolean="true"/> '.
	created := MXTypesObject fromXml: xmlString.
	
	self assert: created boolean = true! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 11/6/2010 12:44'!
testBooleanWrite
	| object xml |
	object := MXTypesObject new
		boolean: true.
	xml := object toXml.
	"<typesobject boolean='true'/>"
	self assert: (xml attributeAt: 'boolean') = 'true'! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 11/6/2010 12:45'!
testDateWrite
	| object xml |
	object := MXTypesObject new
		date: (DateAndTime year: 2010 month: 3 day: 10 hour: 4 minute: 4 second: 4 offset: Duration zero).
	xml := object toXml.
	" '<typesobject date='2010-03-10T04:04:04+00:00'/> "
	self assert: (xml attributeAt: 'date') = '2010-03-10T04:04:04+00:00'! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'NickAger 3/29/2012 17:33'!
testMultipleOptionsRead

	| created xmlString |

	xmlString := '<typesobject><colors>yellow</colors><colors>green</colors></typesobject>'.
	created := MXTypesObject fromXml: xmlString.

	self assert: (created colors at: 1)  = 'yellow'.
	self assert: (created colors at: 2)  = 'green'.! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'NickAger 3/29/2012 17:48'!
testMultipleOptionsWrite

	| object xmlString |
	object := MXTypesObject new
		colors: #( yellow green ).
		
	xmlString := String streamContents: [ :stream |
		object writeXMLOn: stream].
	self assert: xmlString = '<typesobject><colors>yellow</colors><colors>green</colors></typesobject>'! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 11/6/2010 12:46'!
testNumberWrite
	| object xml |
	object := MXTypesObject new
		number: 12345.
	xml := object toXml.
	self assert: (xml attributeAt: 'number') = '12345'! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 8/8/2010 15:48'!
testSingleOptionRead

	| created xmlString |

	xmlString := '<typesobject magnitudeClass="Integer"/> '.
	created := MXTypesObject fromXml: xmlString.
	
	self assert: created magnitudeClass = Integer! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 11/6/2010 12:47'!
testSingleOptionWrite

	| object xml |
	object := MXTypesObject new
		magnitudeClass: Integer.
	xml := object toXml.
	self assert: (xml attributeAt: 'magnitudeClass') = 'Integer'! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 11/6/2010 12:48'!
testStringWrite
	| object xml |
	object := MXTypesObject new
		string: 'a string'.
	xml := object toXml.
	self assert: (xml attributeAt: 'string') = 'a string'! !

Object subclass: #MXTestAddress
	instanceVariableNames: 'postalCode city'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXTestAddress methodsFor: 'accessing' stamp: 'jvds 10/5/2010 22:42'!
city
	^ city! !

!MXTestAddress methodsFor: 'accessing' stamp: 'jvds 10/5/2010 22:42'!
city: anObject
	city := anObject! !

!MXTestAddress methodsFor: 'accessing-magritte' stamp: 'NickAger 1/31/2012 13:00'!
descriptionCity
	<magritteDescription>
	^ MAStringDescription new
		accessor: #city;
		label: 'City';
		beXmlElement;
		priority: 20;
		yourself! !

!MXTestAddress methodsFor: 'accessing-magritte' stamp: 'NickAger 1/31/2012 13:00'!
descriptionPostalCode
	<magritteDescription>
	^ MAStringDescription new
		accessor: #postalCode;
		label: 'Postal Code';
		beXmlAttribute;
		priority: 15;
		yourself! !

!MXTestAddress methodsFor: 'accessing' stamp: 'jvds 10/22/2010 09:24'!
postalCode
	^ postalCode! !

!MXTestAddress methodsFor: 'accessing' stamp: 'jvds 10/22/2010 09:24'!
postalCode: anObject
	postalCode := anObject! !

MXTestAddress subclass: #MXTestPOBoxAddress
	instanceVariableNames: 'pobox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXTestPOBoxAddress methodsFor: 'acessing-magritte' stamp: 'NickAger 1/31/2012 13:22'!
descriptionStreet
	<magritteDescription>
	^ MANumberDescription new
		accessor: #pobox;
		label: 'PO Box';
		beInteger;
		beXmlElement;
		priority: 10;
		yourself! !

!MXTestPOBoxAddress methodsFor: 'accessing' stamp: 'jvds 10/22/2010 09:23'!
pobox
	^ pobox! !

!MXTestPOBoxAddress methodsFor: 'accessing' stamp: 'jvds 10/22/2010 09:23'!
pobox: anObject
	pobox := anObject! !

MXTestAddress subclass: #MXTestStreetAddress
	instanceVariableNames: 'street'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXTestStreetAddress methodsFor: 'acessing-magritte' stamp: 'NickAger 1/31/2012 13:23'!
descriptionStreet
	<magritteDescription>
	^ MAStringDescription new
		accessor: #street;
		label: 'Street';
		beXmlElement;
		priority: 10;
		yourself! !

!MXTestStreetAddress methodsFor: 'accessing' stamp: 'jvds 10/22/2010 09:23'!
street
	^ street! !

!MXTestStreetAddress methodsFor: 'accessing' stamp: 'jvds 10/22/2010 09:23'!
street: anObject
	street := anObject! !

MXObject subclass: #MXFileObject
	instanceVariableNames: 'file abstract'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXFileObject class methodsFor: 'testing' stamp: 'jvds 8/9/2010 15:52'!
isAbstract
	^false! !

!MXFileObject class methodsFor: 'accessing' stamp: 'jvds 8/9/2010 15:38'!
xmlElementName
	^ 'fileobject'! !

!MXFileObject methodsFor: 'accessing' stamp: 'jvds 8/9/2010 15:11'!
abstract
	^ abstract! !

!MXFileObject methodsFor: 'accessing' stamp: 'jvds 8/9/2010 15:11'!
abstract: anObject
	abstract := anObject! !

!MXFileObject methodsFor: 'accessing-description' stamp: 'NickAger 1/31/2012 12:50'!
descriptionAbstract
	<magritteDescription>
	^ MAStringDescription new
		accessor: #abstract;
		label: 'Abstract';
		beXmlExportable;
		yourself! !

!MXFileObject methodsFor: 'accessing-description' stamp: 'NickAger 1/31/2012 12:50'!
descriptionFile
	<magritteDescription>
	^ MAFileDescription new
		accessor: #file;
		label: 'File';
		beXmlExportable;
		yourself! !

!MXFileObject methodsFor: 'accessing-description' stamp: 'NickAger 1/31/2012 12:50'!
descriptionFilePharo: aDescription
	<magritteDescription: #descriptionFile>
	^ aDescription
		kind: MAExternalFileModel;
		yourself! !

!MXFileObject methodsFor: 'accessing' stamp: 'NickAger 1/31/2012 12:45'!
file
	^ file ifNil: [ file := self fileModel new ]! !

!MXFileObject methodsFor: 'accessing' stamp: 'jvds 8/9/2010 15:11'!
file: anObject
	file := anObject! !

!MXFileObject methodsFor: 'accessing' stamp: 'NickAger 1/31/2012 12:44'!
fileModel
	^ (self magritteDescription detect: [ :each |
		each = self descriptionFile ])
			kind! !

MXObject subclass: #MXOneToManySource
	instanceVariableNames: 'label targets inlineTargets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXOneToManySource class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 06:54'!
isAbstract
	^ false! !

!MXOneToManySource class methodsFor: 'accessing' stamp: 'NorbertHartl 02/18/2010 14:42'!
xmlElementName
	^ 'toManySource'! !

!MXOneToManySource methodsFor: 'description' stamp: 'NickAger 1/31/2012 12:52'!
descriptionInlineTargets
	<magritteDescription>
	^ (MAToManyRelationDescription new
		accessor: #inlineTargets;
		label: '1:m inline targets';
		priority: 600)
		reference: MXRelationInlineTarget new magritteDescription;
		beXmlInlineElement;
		yourself! !

!MXOneToManySource methodsFor: 'description' stamp: 'NickAger 1/31/2012 12:51'!
descriptionLabel
	<magritteDescription>
	^ MAStringDescription new
		accessor: #label;
		priority: 100;
		label: 'Label';
		beXmlAttribute;
		yourself! !

!MXOneToManySource methodsFor: 'description' stamp: 'NickAger 1/31/2012 12:53'!
descriptionTargets
	<magritteDescription>
	^ (MAToManyRelationDescription new
		accessor: #targets;
		label: '1:m targets';
		priority: 600)
		reference: MXRelationTarget new magritteDescription;
		xmlElementName: 'elementTargets';
		beXmlExportable;
		yourself! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 08:59'!
inlineTargets
	^ inlineTargets! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 08:59'!
inlineTargets: aCollection
	inlineTargets := aCollection! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:54'!
label
	^ label! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:54'!
label: aString
	label := aString! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:54'!
targets
	^ targets! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:54'!
targets: aCollection
	targets := aCollection! !

MXObject subclass: #MXOneToOneSource
	instanceVariableNames: 'label target inlineTarget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXOneToOneSource class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 06:51'!
isAbstract
	^ false! !

!MXOneToOneSource class methodsFor: 'accessing' stamp: 'NorbertHartl 02/18/2010 14:43'!
xmlElementName
	^ 'toOneSource'! !

!MXOneToOneSource methodsFor: 'description' stamp: 'NickAger 1/31/2012 12:54'!
descriptionInlineTarget
	<magritteDescription>
	^ (MAToOneRelationDescription new
		accessor: #inlineTarget;
		label: '1:1 inline target';
		priority: 600)
		beXmlInlineElement;
		reference: MXRelationInlineTarget new magritteDescription;
		yourself! !

!MXOneToOneSource methodsFor: 'description' stamp: 'NickAger 1/31/2012 12:53'!
descriptionLabel
	<magritteDescription>
	^ MAStringDescription new
		accessor: #label;
		priority: 100;
		label: 'Label';
		beXmlAttribute;
		yourself! !

!MXOneToOneSource methodsFor: 'description' stamp: 'NickAger 1/31/2012 12:54'!
descriptionTarget
	<magritteDescription>
	^ (MAToOneRelationDescription new
		accessor: #target;
		label: '1:1 target';
		priority: 600)
		xmlElementName: 'toOne';
		reference: MXRelationTarget new magritteDescription;
		beXmlExportable;
		yourself! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 08:35'!
inlineTarget
	^ inlineTarget! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 08:36'!
inlineTarget: anObject
	inlineTarget := anObject! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:43'!
label
	^ label! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:42'!
label: aString
	label := aString! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:45'!
target
	^ target! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:44'!
target: anObject
	target := anObject! !

MXObject subclass: #MXRelationEmbedSource
	instanceVariableNames: 'title target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXRelationEmbedSource class methodsFor: 'testing' stamp: 'NorbertHartl 3/15/2010 18:53'!
isAbstract
	^ false! !

!MXRelationEmbedSource class methodsFor: 'accessing' stamp: 'NorbertHartl 3/15/2010 18:56'!
xmlElementName
	^ 'relationEmbedSource'! !

!MXRelationEmbedSource methodsFor: 'accessing-description' stamp: 'NickAger 1/31/2012 12:58'!
descriptionTarget
	<magritteDescription>
	^ MAToOneRelationDescription new
		accessor: #target;
		label: '1:1 embed target';
		priority: 600;
		xmlReadBlock: [ :node | MXRelationEmbedTarget new name: (node attributeAt: 'embedTargetName') ]
			writeBlock: [ :node :value | node attributeAt: 'embedTargetName' put: value name ];
		reference: MXRelationEmbedTarget new magritteDescription;
		yourself! !

!MXRelationEmbedSource methodsFor: 'accessing-description' stamp: 'NickAger 1/31/2012 12:54'!
descriptionTitle
	<magritteDescription>
	^ MAStringDescription new
		accessor: #title;
		priority: 100;
		label: 'Title';
		beXmlAttribute;
		yourself! !

!MXRelationEmbedSource methodsFor: 'accessing' stamp: 'NorbertHartl 3/15/2010 19:01'!
target
	^ target! !

!MXRelationEmbedSource methodsFor: 'accessing' stamp: 'NorbertHartl 3/15/2010 19:01'!
target: anObject
	target := anObject! !

!MXRelationEmbedSource methodsFor: 'accessing' stamp: 'NorbertHartl 3/15/2010 18:53'!
title
	^ title! !

!MXRelationEmbedSource methodsFor: 'accessing' stamp: 'NorbertHartl 3/15/2010 18:53'!
title: aString
	title := aString! !

MXObject subclass: #MXRelationEmbedTarget
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXRelationEmbedTarget class methodsFor: 'testing' stamp: 'NorbertHartl 3/15/2010 18:54'!
isAbstract
	^ false! !

!MXRelationEmbedTarget class methodsFor: 'accessing' stamp: 'NorbertHartl 3/15/2010 18:56'!
xmlElementName
	^ 'relationEmbedTarget'! !

!MXRelationEmbedTarget methodsFor: 'description' stamp: 'NickAger 1/31/2012 12:58'!
descriptionName
	<magritteDescription>
	^ MAStringDescription new
		accessor: #name;
		priority: 100;
		label: 'Name';
		beXmlAttribute;
		yourself! !

!MXRelationEmbedTarget methodsFor: 'accessing' stamp: 'NorbertHartl 3/15/2010 18:54'!
name
	^ name! !

!MXRelationEmbedTarget methodsFor: 'accessing' stamp: 'NorbertHartl 3/15/2010 18:54'!
name: aString
	name := aString! !

MXObject subclass: #MXRelationInlineTarget
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXRelationInlineTarget class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 13:36'!
isAbstract
	^ false! !

!MXRelationInlineTarget class methodsFor: 'accessing' stamp: 'NorbertHartl 02/18/2010 14:43'!
xmlElementName
	^ 'inlineTarget'! !

!MXRelationInlineTarget methodsFor: 'description' stamp: 'NickAger 1/31/2012 12:59'!
descriptionTitle
	<magritteDescription>
	^ MAStringDescription new
		accessor: #title;
		priority: 100;
		label: 'Title';
		beXmlAttribute;
		yourself! !

!MXRelationInlineTarget methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 13:36'!
title
	^ title! !

!MXRelationInlineTarget methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 13:36'!
title: aString
	title := aString! !

MXObject subclass: #MXRelationTarget
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXRelationTarget class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 06:51'!
isAbstract
	^ false! !

!MXRelationTarget class methodsFor: 'accessing' stamp: 'NorbertHartl 02/18/2010 14:54'!
xmlElementName
	^ 'elementtarget'! !

!MXRelationTarget methodsFor: 'description' stamp: 'NickAger 1/31/2012 12:59'!
descriptionTitle
	<magritteDescription>
	^ MAStringDescription new
		accessor: #title;
		priority: 100;
		label: 'Title';
		beXmlAttribute;
		yourself! !

!MXRelationTarget methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:42'!
title
	^ title! !

!MXRelationTarget methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:42'!
title: aString
	title := aString! !

MXObject subclass: #MXSimpleObject
	instanceVariableNames: 'title abstract token index date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXSimpleObject class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 05:20'!
isAbstract
	^ false! !

!MXSimpleObject class methodsFor: 'accessing' stamp: 'NorbertHartl 02/18/2010 14:44'!
xmlElementName
	^ 'simpleobject'! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:26'!
abstract
	^ abstract! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:26'!
abstract: aString
	abstract := aString! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
date
	^ date! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
date: aDate
	date := aDate! !

!MXSimpleObject methodsFor: 'description' stamp: 'NickAger 1/31/2012 13:00'!
descriptionAbstract
	<magritteDescription>
	^ MAStringDescription new
		accessor: #abstract;
		priority: 150;
		label: 'Abstract';
		beXmlElement;
		yourself! !

!MXSimpleObject methodsFor: 'description' stamp: 'NickAger 1/31/2012 13:00'!
descriptionDate
	<magritteDescription>
	^ MADateDescription new
		accessor: #date;
		priority: 350;
		label: 'Date';
		beXmlElement;
		yourself! !

!MXSimpleObject methodsFor: 'description' stamp: 'NickAger 1/31/2012 13:00'!
descriptionIndex
	<magritteDescription>
	^ MANumberDescription new
		accessor: #index;
		priority: 200;
		label: 'Index';
		beXmlAttribute;
		yourself! !

!MXSimpleObject methodsFor: 'description' stamp: 'NickAger 1/31/2012 13:00'!
descriptionTitle
	<magritteDescription>
	^ MAStringDescription new
		accessor: #title;
		priority: 100;
		label: 'Title';
		beXmlAttribute;
		yourself! !

!MXSimpleObject methodsFor: 'description' stamp: 'NickAger 2/1/2012 14:03'!
descriptionToken
	<magritteDescription>
	^ MAStringDescription new
		accessor: #token;
		priority: 180;
		label: 'Token';
		beXmlChildAttribute;
		xmlAttributeName: 'type';
		yourself! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
index
	^ index! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
index: aNumber
	index := aNumber! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
title
	^ title! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:11'!
title: aString
	title := aString! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NickAger 2/1/2012 14:01'!
token
	^ token! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NickAger 2/1/2012 14:01'!
token: anObject
	token := anObject! !

MXObject subclass: #MXTypesObject
	instanceVariableNames: 'string number date boolean magnitudeClass colors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-XMLBinding'!

!MXTypesObject class methodsFor: 'testing' stamp: 'NorbertHartl 3/16/2010 15:14'!
isAbstract
	^ false! !

!MXTypesObject class methodsFor: 'accessing' stamp: 'NorbertHartl 3/16/2010 15:23'!
xmlElementName
	^ 'typesobject'! !

!MXTypesObject methodsFor: 'accessing' stamp: 'jvds 8/5/2010 00:03'!
boolean
	^ boolean! !

!MXTypesObject methodsFor: 'accessing' stamp: 'jvds 8/5/2010 00:03'!
boolean: anObject
	boolean := anObject! !

!MXTypesObject methodsFor: 'accessing' stamp: 'jvds 8/31/2010 18:34'!
colors
	^ colors! !

!MXTypesObject methodsFor: 'accessing' stamp: 'jvds 8/31/2010 18:34'!
colors: anObject
	colors := anObject! !

!MXTypesObject methodsFor: 'accessing' stamp: 'NorbertHartl 3/16/2010 15:14'!
date
	^ date! !

!MXTypesObject methodsFor: 'accessing' stamp: 'NorbertHartl 3/16/2010 15:14'!
date: aDate
	date := aDate! !

!MXTypesObject methodsFor: 'description' stamp: 'NickAger 1/31/2012 13:27'!
descriptionBoolean
	<magritteDescription>
	^ MABooleanDescription new
		accessor: #boolean;
		priority: 120;
		label: 'Boolean';
		beXmlAttribute;
		yourself! !

!MXTypesObject methodsFor: 'description' stamp: 'NickAger 3/29/2012 17:44'!
descriptionColors
	<magritteDescription>
	^ MAMultipleOptionDescription new
		accessor: #colors;
		options: #(#red #yellow #blue #green);
		accessor: #colors;
		beXmlExportable;
		yourself! !

!MXTypesObject methodsFor: 'description' stamp: 'NickAger 1/31/2012 13:27'!
descriptionDate
	<magritteDescription>
	^ MADateDescription new
		accessor: #date;
		priority: 110;
		label: 'Date';
		beXmlAttribute;
		yourself! !

!MXTypesObject methodsFor: 'description' stamp: 'NickAger 1/31/2012 13:27'!
descriptionMagnitudeClass
	<magritteDescription>
	^ MASingleOptionDescription new
		options: Magnitude allSubclasses;
		reference: MAClassDescription new;
		accessor: #magnitudeClass;
		beXmlAttribute;
		yourself! !

!MXTypesObject methodsFor: 'description' stamp: 'NickAger 1/31/2012 13:27'!
descriptionNumber
	<magritteDescription>
	^ MANumberDescription new
		accessor: #number;
		priority: 105;
		label: 'Number';
		beXmlAttribute;
		yourself! !

!MXTypesObject methodsFor: 'description' stamp: 'NickAger 1/31/2012 13:27'!
descriptionString
	<magritteDescription>
	^ MAStringDescription new
		accessor: #string;
		priority: 100;
		label: 'String';
		beXmlAttribute;
		yourself! !

!MXTypesObject methodsFor: 'accessing' stamp: 'jvds 8/8/2010 15:28'!
magnitudeClass
	^ magnitudeClass! !

!MXTypesObject methodsFor: 'accessing' stamp: 'jvds 8/8/2010 15:28'!
magnitudeClass: anObject
	magnitudeClass := anObject! !

!MXTypesObject methodsFor: 'accessing' stamp: 'NorbertHartl 3/16/2010 15:17'!
number
	^ number! !

!MXTypesObject methodsFor: 'accessing' stamp: 'NorbertHartl 3/16/2010 15:17'!
number: aNumber
	number := aNumber! !

!MXTypesObject methodsFor: 'accessing' stamp: 'NorbertHartl 3/16/2010 15:16'!
string
	^ string! !

!MXTypesObject methodsFor: 'accessing' stamp: 'NorbertHartl 3/16/2010 15:16'!
string: aString
	string := aString! !
